/*
日历 calendar
相机 camera
通讯录 contacts
位置信息 location
麦克风 microphone
电话 phone
身体传感器 sensor
短信 sms
存储空间 storage
*/
function apialert(str){
  alert(str);
}
function hasPermission(one_per) {

    var perms = new Array();
    if (one_per) {
        perms.push(one_per);
    } else {
        var prs = document.getElementsByName("p_list");
        for (var i = 0; i < prs.length; i++) {
            if (prs[i].checked) {
                perms.push(prs[i].value);
            }
        }
    }
    var rets = api.hasPermission({
        list: perms
    });
    if (!one_per) {
        apialert('判断结果：' + JSON.stringify(rets));
        return;
    }
    //alert("hasPermission:"+one_per+" / return:"+rets);
    return rets;
}

function reqPermission(one_per, callback) {
    var perms = new Array();
    if (one_per) {
        perms.push(one_per);
    } else {
        var prs = document.getElementsByName("p_list_r");
        for (var i = 0; i < prs.length; i++) {
            if (prs[i].checked) {
                perms.push(prs[i].value);
            }
        }
    }
    api.requestPermission({
        list: perms,
        code: 100001
    }, function(ret, err) {
        if (callback) {
            callback();
            return;
        }
        // var str = '请求结果：\n';
        // str += '请求码: ' + ret.code + '\n';
        // str += "是否勾选\"不再询问\"按钮: " + (ret.never ? '是' : '否') + '\n';
        // str += '请求结果: \n';
        // var list = ret.list;
        // for (var i in list) {
        //     str += list[i].name + '=' + list[i].granted + '\n';
        // }

        // if( list[i].granted){
        //
        // }

        console.log(JSON.stringify(ret));
    });
}

function opWithPermission(perm) {
    if (!confirmPer(perm)) {
        return;
    }
    if ('calendar' == perm) {
        //操作日历
    } else if ('camera' == perm) {
        api.getPicture({
            sourceType: 'camera',
            mediaValue: 'pic',
            destinationType: 'url',
        }, function(ret, err) {
            if (ret) {
                apialert(JSON.stringify(ret));
            } else {
                apialert(JSON.stringify(err));
            }
        });
    } else if ('contacts' == perm) {
        api.openContacts({
            test: true
        }, function(ret, err) {
            if (ret && ret.status) {
                apialert(JSON.stringify(ret));
            } else {
                apialert(JSON.stringify(err));
            }
        });
    } else if ('location' == perm) {
        api.getLocation(function(ret, err) {
            if (ret && ret.status) {
                apialert(JSON.stringify(ret));
            } else {
                apialert(JSON.stringify(err));
            }
        });
    } else if ('microphone' == perm) {
        api.startRecord({
            path: 'fs://perm-test.amr'
        });
    } else if ('phone' == perm) {
        api.call({
            type: 'tel',
            number: '10086'
        });
    } else if ('sensor' == perm) {
        //操作身体传感器
    } else if ('sms' == perm) {
        api.sms({
            numbers: ['10086'],
            text: '余额',
            silent: true
        });
    } else if ('storage' == perm) {
        api.readFile({
            path: 'fs://test.txt'
        }, function(ret, err) {
            if (ret.status) {
                console.log('readFile: ' + ret.data);
            } else {
                apialert(err.msg + ": \n" + api.fsDir);
            }
        });
    }
}

function confirmPer(perm,func,confirmtxt) {
    var has = hasPermission(perm);
    var ret = true;
    var txt = confirmtxt?confirmtxt:'没有获得 ' + perm + " 权限\n是否前往设置？";

    if (!has || !has[0] || !has[0].granted) {
        api.confirm({
            title: '提醒',
            msg: txt,
            buttons: ['开启', '取消']
        }, function(ret, err) {
            if (1 == ret.buttonIndex) {
                reqPermission(perm,func);
            }
        });
        ret = false;
    }
    //alert("hasPermission:"+perm+" / return:"+ret);
    return ret;
}
